/* BSD `setjmp' entry point to `sigsetjmp (..., 1)'.  NIOS2 version.
   Copyright (C) 1996, 1997, 2000, 2008 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

/* This just does a tail-call to `__sigsetjmp (ARG, 1)'.
   We cannot do it in C because it must be a tail-call, so frame-unwinding
   in setjmp doesn't clobber the state restored by longjmp.  */

#include <sysdep.h>

ENTRY (setjmp)
	movi r5, 1		/* Pass a second argument of one.  */
#if defined (__PIC__) || defined (PIC)
        nextpc r2
1:      movhi r3, %hiadj(_GLOBAL_OFFSET_TABLE_ - 1b)
        addi r3, r3, %lo(_GLOBAL_OFFSET_TABLE_ - 1b)
        add r2, r2, r3
        ldw r2, %call(C_SYMBOL_NAME(__sigsetjmp))(r2)
        jmp r2
#else
        jmpi C_SYMBOL_NAME (__sigsetjmp)
#endif
	.size	setjmp, . - setjmp
